Subject: Re: bug#63393: [PATCH 0/2] Fix libstdc++.so and gcc-toolchain

From: John Kehayias <[email-masked]>
Date: Sun, 16 Jul 2023 18:33:52 +0000

Hello,

On Thu, May 11, 2023 at 03:38 PM, Ludovic Courtès wrote:

> Hi,
>
> Simon Tournier <[email-masked]> skribis:
>
>> * gnu/packages/commencement.scm (make-gcc-toolchain): Add 'lib' outputs.
>
> [...]
>
>>                                      (filter-map (match-lambda
>>                                                    (("libc-debug" . _) #f)
>>                                                    (("libc-static" . _) #f)
>> +                                                  (("gcc-lib" . _) #f)
>> +                                                  (("gcc-debug" . _) #f)
>
> I would include gcc:lib in “out” (thus not adding a “lib” output to
> ‘gcc-toolchain’).
>
> Yes, gcc:lib includes *.a and *.la, but those are already part of the
> ‘gcc-toolchain’ closure:
>
> $ guix size gcc-toolchain |head -6
> store item                                                       total    self
> /gnu/store/jv78mm3dmr6fl2hhy1bkbhfpm702v3gq-gcc-12.3.0             292.6   169.4  41.2%
> /gnu/store/zh4x65snfis7svs6906gj1z8i7dx2j3m-binutils-2.38           95.5    54.9  13.4%
> /gnu/store/g8p09w6r78hhkl2rv1747pcp9zbk6fxv-guile-3.0.9            134.0    53.1  12.9%
> /gnu/store/gsjczqir1wbz8p770zndrpw4rnppmxi3-glibc-2.35              40.6    38.8   9.4%
> /gnu/store/gmv6n5vy5qcsn71pkapg2hnknyn1p7g3-gcc-12.3.0-lib          76.8    36.2   8.8%
>
> However, I’d leave out gcc:debug because (0) it’s unrelated :-), (1)
> ‘gcc-final’ has no “debug” output, and (2) it’s really for a niche
> (folks developing compiler plugins, typically).
>
> I’d also leave out the /lib directory of Binutils, which is again rarely
> useful.
>
> WDYT?
>

I don't have any strong opinions on the organization here of these
outputs, happy to defer to whatever others decide here. It would be nice
to have this sorted and taken care of before we forget about it :)

However, I think this message from Kaelyn only went to the bug number
(just saw that as I went to reply here) so I'm including it here:

On Tue, May 09, 2023 at 06:50 PM, Kaelyn wrote:

> Hi,
>
> I like the direction of this patch. However, if gcc-toolchain:lib is
> intended to provide the runtime libraries when the full compiler isn't
> needed, then I think the .a and .la files should be moved back to the
> main gcc-toolchain output (or a separate :static output) since they
> are for static linking and the .a files in particular can be sizeable.
>
> Cheers,
> Kaelyn